/*
  http://math.hws.edu/orr/s04/cpsc225/mousedemo.cc

*/
/* Scotty Orr
 * This program is a simple mouse demo program that is related
 * to your project. This program does nothing except print out
 * an 'X' or an 'O' each time you click the left mouse button.
 * To end this program type control-c. Feel free to use any parts
 * of this that you want to (except for my comments) for your project.
 * In addition to adding a bunch of code, there are several things
 * here that would need to be changed.  (ie, You can't just "add" code
 * to this and make your program work.)
 */

#include "curses.h"
#include <iostream>
#include <cstdlib>   // <- this probably not needed under SuSE
using namespace std;

// Prototypes and global var for Prof. Eck's routines
void endCurses();
void startCurses();
void drawFrame(int, int, int, int);

bool curses_started = false;

int main()
{
   startCurses(); // good idea to startCurses() at the very beginning
                  // unless you are going to print some console instructions
                  // with cout (like Prof. Eck's program) - but everybody
                  // knows how to play tic tac toe...

   char player;
   int mc, play = 1; // mc is for mouse click

   curs_set(0); // hide the cursor
   drawFrame(0, 0, LINES-1, COLS-1);

   // enable the mouse
   MEVENT event;
   mousemask(ALL_MOUSE_EVENTS, NULL);

   while (true) // you might want to say "while (play <= 9)" here
   {
      // ***** This code prints a message, centered horizontally
      //       near the top of the screen
      if (play%2 == 1)
         player = 'X';
      else
         player = 'O';
      move(4, (COLS-18)/2);
      addch(player | A_BOLD);
      refresh();
      addstr(", it is your move.");
      refresh();

      // ***** This loop ignores keypresses and bad clicks
      while(true)
      {
         mc = getch();
//       if ((mc == KEY_MOUSE) && (getmouse(&event) == OK))
         if ((mc == KEY_MOUSE) && (getmouse() == OK))
         {
            if (event.bstate & BUTTON1_CLICKED)
            {  // this is *possibly* one place where you could add/change
               // a bunch of code (including function calls)...
               move(event.y, event.x);
               addch(player);
               refresh();  // don't forget to refresh()
                           // (or call a function that refreshes...)
               break;
            }
         }
      }
      play ++;
   }

   endCurses();
   return 0;
}

//---------------------------------------------------------------
//   Professor Eck's routines
//---------------------------------------------------------------

/*
 * This will exit curses mode and return the console to the usual
 * line-oriented input/output mode.  If it is called when curses
 * mode is not in effect, it will have no effect.
 *
 */
void endCurses()
{
   if (curses_started && !isendwin())
      endwin();
}

/*
 * This will put the console into curses mode.  If curses mode is being
 * entered for the first time, the screen will be cleared.  If it is
 * being re-entered after a call to endCurses(), then the previous
 * screen contents will be restored.
 */
void startCurses()
{
   if (curses_started)
   {
      refresh();
   }
   else
   {
      initscr();
      cbreak();
      noecho();
      intrflush(stdscr, false);
      keypad(stdscr, true);
//      atexit(endCurses);  // Make sure endCurses() is called when program ends.
      curses_started = true;
   }
}

//---------------------------------------------------------------

/*
 * This routine draws a frame around a specified part of the console
 * screen, using special characters such as ACS_ULCORNER and ACS_VLINE.
 * The frame extends from startrow to endrow vertically and from
 * startcol to endcol horizontally.  (Rows and columns are numbered
 * starting from 0.)  Note that the interior of the frame extends
 * from startrow+1 to endrow-1 vertically and from startcol+1 to
 * endcol-1 horizontally.
 */
void drawFrame(int startrow, int startcol, int endrow, int endcol)
{
   int saverow, savecol;
   getyx(stdscr,saverow,savecol);
   mvaddch(startrow,startcol,ACS_ULCORNER);
   for (int i = startcol + 1; i < endcol; i++)
      addch(ACS_HLINE);
   addch(ACS_URCORNER);
   for (int i = startrow +1; i < endrow; i++)
   {
      mvaddch(i,startcol,ACS_VLINE);
      mvaddch(i,endcol,ACS_VLINE);
   }
   mvaddch(endrow,startcol,ACS_LLCORNER);
   for (int i = startcol + 1; i < endcol; i++)
      addch(ACS_HLINE);
   addch(ACS_LRCORNER);
   move(saverow,savecol);
   refresh();
}